//001 fonctionne, avec voyant !!!!!
//002 PWM
//003 freq
//    arpschuino32 core mapping

//arpschuino32_16pwm
//001 fonctionne avec adressage en dur
//    calcul automatique de la fréquence
//002 arpschuino lib

#include "dmx_t.h" // https://github.com/luksal/ESP32-DMX-RX
#include "arpschuino32_core.h"
#include "arpschuino.h"

int nbre_circuits = 16;
uint16_t address = 100;

int readcycle = 0;

const int resolution = 14;




void setup() {
  Serial.begin(115200);
  DMX::Initialize();
  Arp_arpdress_board();//prise en charge de l'arpdress board
  uint32_t freq = 40000000;
  for(int i=1;i<resolution;i++)
  {
    freq=freq/2;
  }
  Serial.print("arpschuino32 16 pwm; ");
  Serial.print("resolution = ");
  Serial.print(resolution);
  Serial.print(" bits; freq = ");
  Serial.print(freq);
  Serial.println(" hz");  
  Serial.print("DMX address = ");
  Serial.println(address);
  for(int i=0;i<nbre_circuits;i++)
  {
    ledcSetup(i, freq, resolution);// configure LED PWM functionalitites
    ledcAttachPin(Arp[i], i);// attach the channel to the GPIO to be controlled
  }
  pinMode(LED_BUILTIN,OUTPUT);
  pinMode(ArpDMXControl,OUTPUT);
  digitalWrite(ArpDMXControl,LOW); 
}

void loop()
{
  if(millis() - readcycle >= 40)
  {
    readcycle = millis();
    //Serial.print(readcycle);
      
    if(DMX::IsHealthy())
      Arp_led_temoin ();
    else  digitalWrite(LED_BUILTIN,LOW);


    for(int i=0;i<nbre_circuits;i++)
    {    
      uint16_t level14bits = (DMX::Read(i+address)*DMX::Read(i+address)>>2);
      ledcWrite(i, level14bits);
    }
  }
}
